var Catalog = function() {
	this.courses = [];
};

Catalog.prototype.addCourse = function(course) {
	if (!(course instanceof Course)) {
		throw new Error('You must pass a course object here');
	}
	return this;
};

Catalog.prototype.render = function() {
	_.each(this.courses, function(course) {
		$('#js-course-container').append(course.render());
	});
	return this;
};

// A "course" acts as the "base class" for individual
// department courses.
var Course = function(courseId, courseTitle) {
	this.courseId    = courseId;
	this.courseTitle = courseTitle;
	this.students = [];
	this.lectures = [];
};

_.extend(Course.prototype, {

	template: _.template($("#app-template").html()),

	department: 'Department not listed',

	addStudent: function(name) {
		this.students.push(name);
		return this;
	},

	addLecture: function(name) {
		this.lectures.push(name);
		return this;
	},

	render: function() {
		return this.template(this);
	}

});

var CS = function() {
	Course.apply(this, arguments);
};

// Create a temporary object so we can get an instance
// of the course and
var temp = function() {}
temp.prototype = Course.prototype;

// The CS "prototype chain" now has an
CS.prototype = new temp();

CS.prototype.department = 'Computer Science';

var Econ = function() {
	Course.apply(this, arguments);
};

// Save a few lines, but breaks in IE < 9
Econ.prototype = Object.create(Course.prototype);

Econ.prototype.department = 'Computer Science';
