var nameGenerator = {

  // Ask the user for their name, update
  // the name on the, and return the nameGenerator object
  start: function() {
    var name = this.askForName();
    this.updateName(name);
    return this;
  },

  // Ask for the user's name, setting it to "this.name"
  askForName: function() {
    var name = prompt('What is your name');
    if (!name) return this.askForName();
    return name;
  },

  // Set the user's name in the h1 tag.
  updateName: function(name) {
    if (!name) {
      throw new Error('A name must be provided');
    }
    this.name = name;
    this.setDisplayName();
    return this;
  },

  // Set the display name for the user.
  setDisplayName: function() {
    $('.js-name-container').html('My Name: ' + this.name)
    return this;
  }

};

var client = nameGenerator.start();

$('form').on('submit', function(event) {
  event.preventDefault();
  var newName = $('[name=new_name]').val();
  client.updateName(newName);
});