var nameGenerator = {

  // Ask the user for their name, update
  // the name on the object, show the form,
  // and return the nameGenerator object.
  start: function() {
    var name = this.askForName();
    $('.js-name-form').show()
    this.updateName(name);
    return this;
  },

  // Ask for the user's name, setting it to "this.name"
  askForName: function() {
    var name = prompt('What is your name');
    if (!name) return this.askForName();
    return name;
  },

  // Set the user's name in the h1 tag.
  updateName: function(name) {
    if (!name) return this.showError('A name must be provided');
    this.name = name;
    this.setDisplayName();
    return this;
  },

  // Show the error
  showError: function(msg) {
    $('.js-field-container').addClass('has-error');
    $('.js-error-container').html('<p class="help-block">' + msg + '</p>');
    return this;
  },

  hideError: function() {
    $('.js-field-container').removeClass('has-error');
    $('.js-error-container').html('');
    return this;
  },

  setDisplayName: function() {
    this.hideError();
    $('.js-name-container').html('My Name: ' + this.name)
    return this;
  }

};

$(function() {

  var client = nameGenerator.start();

  $('form').on('submit', function(event) {
    event.preventDefault();
    var $nameField = $('[name=new_name]');
    client.updateName($nameField.val());
    $nameField.val('')
  });

});